## lemonldap-ng 0.8.3.1

=== Makefile ===
#!/usr/bin/make

VERSION=`head -n1 changelog |sed -e 's/lemonldap-ng (//' -e 's/).*$$//'`
HANDLERDIR=lemonldap-ng-handler
PORTALDIR=lemonldap-ng-portal
MANAGERDIR=lemonldap-ng-manager
EXAMPLEDIRBUILD=`pwd`/example/
EXAMPLEDIR=$(EXAMPLEDIRBUILD)
EXAMPLECONFDIR=$(EXAMPLEDIR)conf/
EXAMPLELANG=en

all:	handler manager portal

handler:	handler_conf
	$(MAKE) -C ${HANDLERDIR}
	touch handler

portal:		portal_conf
	$(MAKE) -C ${PORTALDIR}
	touch portal

manager:	manager_conf
	$(MAKE) -C ${MANAGERDIR}
	touch manager

configure:	handler_conf portal_conf manager_conf

handler_conf:
	cd ${HANDLERDIR}; perl Makefile.PL INSTALLDIRS=$(INSTALLDIRS)
	touch handler_conf

portal_conf:
	cd ${PORTALDIR}; perl Makefile.PL INSTALLDIRS=$(INSTALLDIRS)
	touch portal_conf

manager_conf:
	cd ${MANAGERDIR}; perl Makefile.PL INSTALLDIRS=$(INSTALLDIRS)
	touch manager_conf

test:		manager_test handler_test portal_test

manager_test:	manager
	$(MAKE) -C ${MANAGERDIR} test

handler_test:	handler
	$(MAKE) -C ${HANDLERDIR} test INST_ARCHLIB=../${MANAGERDIR}/blib/lib/

portal_test:	portal
	$(MAKE) -C ${PORTALDIR} test INST_ARCHLIB=../${MANAGERDIR}/blib/lib/

install:	handler_install portal_install manager_install

handler_install:	handler
	$(MAKE) -C ${HANDLERDIR} install
	touch handler_install

portal_install:		portal
	$(MAKE) -C ${PORTALDIR} install
	touch portal_install

manager_install:	manager
	$(MAKE) -C ${MANAGERDIR} install
	touch manager_install

distclean:	clean

clean:		handler_clean portal_clean manager_clean
	rm -rf example
	find . -name '*.gz' -exec rm -vf {} \;

handler_clean:
	- $(MAKE) -C ${HANDLERDIR} distclean
	rm -vf handler*

portal_clean:
	- $(MAKE) -C ${PORTALDIR} distclean
	rm -vf portal*

manager_clean:
	- $(MAKE) -C ${MANAGERDIR} distclean
	rm -vf manager*

example: all
	mkdir -p ${EXAMPLEDIRBUILD}/portal ${EXAMPLEDIRBUILD}/manager ${EXAMPLEDIRBUILD}/handler ${EXAMPLEDIRBUILD}/conf
	chmod 1777 ${EXAMPLEDIRBUILD}/conf
	cp -a ${HANDLERDIR}/example/* ${EXAMPLEDIRBUILD}/handler
	cp -a ${PORTALDIR}/example/* ${EXAMPLEDIRBUILD}/portal
	cp -a ${MANAGERDIR}/example/* ${EXAMPLEDIRBUILD}/manager
	cp -a _example/* ${EXAMPLEDIRBUILD}
	find ${EXAMPLEDIRBUILD} -type f -exec perl -i -pe 's#__DIR__/?#'${EXAMPLEDIR}'#g;s#__CONFDIR__/?#'${EXAMPLECONFDIR}'#g;' {} \;
	@echo
	@echo "Example is ready."
	@echo
	@echo "1 - Add this in your Apache configuration file:"
	@echo "    with Apache-1.3.x"
	@echo
	@echo "      include ${EXAMPLEDIR}apache.conf"
	@echo
	@echo "    or with Apache-2.x:"
	@echo
	@echo "      include ${EXAMPLEDIR}apache2.conf"
	@echo
	@echo "2 - Add test.example.com and auth.example.com in your /etc/hosts or"
	@echo "    modify apache.conf to use NameVirtualHost, different port or"
	@echo "    address;"
	@echo
	@echo "    cat ${EXAMPLEDIRBUILD}/for_etc_hosts >> /etc/hosts"
	@echo
	@echo "3 - Use the manager at http://manager.example.com/ (after apache restart)"
	@echo "    or edit ${EXAMPLEDIR}/conf/lmConf-1 and set ldapServer and ldapBase."
	@echo
	@echo "4 - Restart Apache (or Apache2)"
	@echo
	@echo "5 - Try to connect to http://test.example.com/"

uninstall:	configure handler_uninstall portal_uninstall manager_uninstall

handler_uninstall:	handler
	$(MAKE) -C ${HANDLERDIR} uninstall
	rm -vf handler_uninstall

portal_uninstall:		portal
	$(MAKE) -C ${PORTALDIR} uninstall
	rm -vf portal_uninstall

manager_uninstall:	manager
	$(MAKE) -C ${MANAGERDIR} uninstall
	rm -vf manager_uninstall

dist:	clean
	- $(MAKE) clean
	mkdir -p lemonldap-ng-$(VERSION)
	- cp -pR lemonldap-ng-manager/ lemonldap-ng-portal/ lemonldap-ng-handler/ * lemonldap-ng-$(VERSION)
	- dir=lemonldap-ng-$(VERSION); find $$dir -name .svn -exec rm -rf {} \; 2>/dev/null
	rm -rf lemonldap-ng-$(VERSION)/lemonldap-ng-$(VERSION)
	tar czf lemonldap-ng-$(VERSION).tar.gz lemonldap-ng-$(VERSION)
	rm -rf lemonldap-ng-$(VERSION)

cpan:	clean configure handler_cpan portal_cpan manager_cpan

handler_cpan:	handler_conf
	$(MAKE) -C ${HANDLERDIR} dist
	mv ${HANDLERDIR}/Lemonldap*.gz .

portal_cpan:		portal_conf
	$(MAKE) -C ${PORTALDIR} dist
	mv ${PORTALDIR}/Lemonldap*.gz .

manager_cpan:	manager_conf
	$(MAKE) -C ${MANAGERDIR} dist
	mv ${MANAGERDIR}/Lemonldap*.gz .

static_example:	example
	mkdir -p ${EXAMPLEDIRBUILD}/static
	cd ${EXAMPLEDIRBUILD}/static/;ln -s ../manager/imgs;cd -
	scripts/make_static_example.pl ${EXAMPLEDIRBUILD}/manager/index.pl ${EXAMPLEDIRBUILD}/static/index.html $(EXAMPLELANG)

documentation:
	cd doc && ../scripts/doc.pl

## lemonldap-ng 0.9.2

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,15 @@
 EXAMPLEDIRBUILD=`pwd`/example/
 EXAMPLEDIR=$(EXAMPLEDIRBUILD)
 EXAMPLECONFDIR=$(EXAMPLEDIR)conf/
+EXAMPLELASPDIR=$(EXAMPLEDIR)liberty-alliance-sp-portal/
+EXAMPLELASPDIRBUILD=$(EXAMPLELASPDIR)
 EXAMPLELANG=en
+EXAMPLEPORTALDIRBUILD=$(EXAMPLEDIRBUILD)portal/
+EXAMPLEHANDLERDIRBUILD=$(EXAMPLEDIRBUILD)handler/
+EXAMPLEMANAGERDIRBUILD=$(EXAMPLEDIRBUILD)manager/
+EXAMPLEPORTALDIR=$(EXAMPLEDIR)portal/
+EXAMPLEHANDLERDIR=$(EXAMPLEDIR)handler/
+EXAMPLEMANAGERDIR=$(EXAMPLEDIR)manager/
 
 all:	handler manager portal
 
@@ -37,7 +45,7 @@
 	cd ${MANAGERDIR}; perl Makefile.PL INSTALLDIRS=$(INSTALLDIRS)
 	touch manager_conf
 
-test:		manager_test handler_test portal_test
+test:		manager handler portal manager_test handler_test portal_test
 
 manager_test:	manager
 	$(MAKE) -C ${MANAGERDIR} test
@@ -66,7 +74,7 @@
 
 clean:		handler_clean portal_clean manager_clean
 	rm -rf example
-	find . -name '*.gz' -exec rm -vf {} \;
+	rm -vf *gz
 
 handler_clean:
 	- $(MAKE) -C ${HANDLERDIR} distclean
@@ -83,11 +91,15 @@
 example: all
 	mkdir -p ${EXAMPLEDIRBUILD}/portal ${EXAMPLEDIRBUILD}/manager ${EXAMPLEDIRBUILD}/handler ${EXAMPLEDIRBUILD}/conf
 	chmod 1777 ${EXAMPLEDIRBUILD}/conf
-	cp -a ${HANDLERDIR}/example/* ${EXAMPLEDIRBUILD}/handler
-	cp -a ${PORTALDIR}/example/* ${EXAMPLEDIRBUILD}/portal
-	cp -a ${MANAGERDIR}/example/* ${EXAMPLEDIRBUILD}/manager
+	cp -a ${HANDLERDIR}/example/* ${EXAMPLEHANDLERDIRBUILD}
+	cp -a ${PORTALDIR}/example/* ${EXAMPLEPORTALDIRBUILD}
+	#perl -l -e '$$a="${EXAMPLELASPDIRBUILD}";$$a=~s#/$$##;print $$a;'
+	#perl -l -e '$$ARGV[0]=~s#/$$##;print $$ARGV[0];' ${EXAMPLELASPDIRBUILD}
+	mv ${EXAMPLEDIRBUILD}/portal/AuthLA $$(echo ${EXAMPLELASPDIRBUILD}|sed -e 's/\/$$//')
+	cp -a ${MANAGERDIR}/example/* ${EXAMPLEMANAGERDIRBUILD}
 	cp -a _example/* ${EXAMPLEDIRBUILD}
-	find ${EXAMPLEDIRBUILD} -type f -exec perl -i -pe 's#__DIR__/?#'${EXAMPLEDIR}'#g;s#__CONFDIR__/?#'${EXAMPLECONFDIR}'#g;' {} \;
+	find ${EXAMPLELASPDIRBUILD} -type f -exec perl -i -pe 's#__DIR__/?#'${EXAMPLELASPDIR}'#g;s#__CONFDIR__/?#'${EXAMPLECONFDIR}'#g;s#__SKINDIR__/?#'${EXAMPLEPORTALDIR}'skins/#g;' {} \;
+	find ${EXAMPLEDIRBUILD} -type f -exec perl -i -pe 's#__DIR__/?#'${EXAMPLEDIR}'#g;s#__CONFDIR__/?#'${EXAMPLECONFDIR}'#g;s#__SKINDIR__/?#'${EXAMPLEPORTALDIR}'skins/#g;' {} \;
 	@echo
 	@echo "Example is ready."
 	@echo
@@ -136,6 +148,9 @@
 	tar czf lemonldap-ng-$(VERSION).tar.gz lemonldap-ng-$(VERSION)
 	rm -rf lemonldap-ng-$(VERSION)
 
+debian-dist:	dist
+	mv lemonldap-ng-$(VERSION).tar.gz lemonldap-ng_$(VERSION).orig.tar.gz
+
 cpan:	clean configure handler_cpan portal_cpan manager_cpan
 
 handler_cpan:	handler_conf
@@ -152,7 +167,7 @@
 
 static_example:	example
 	mkdir -p ${EXAMPLEDIRBUILD}/static
-	cd ${EXAMPLEDIRBUILD}/static/;ln -s ../manager/imgs;cd -
+	cd ${EXAMPLEDIRBUILD}/static/;cp -a ../manager/{imgs,theme} .;cd -
 	scripts/make_static_example.pl ${EXAMPLEDIRBUILD}/manager/index.pl ${EXAMPLEDIRBUILD}/static/index.html $(EXAMPLELANG)
 
 documentation:

## lemonldap-ng 0.9.3.4

=== Makefile ===
#!/usr/bin/make

# Prefix for packaging
DESTDIR=

PERL=$$(which perl)
# Perl options
#PERLOPTIONS="INSTALLDIRS=vendor"
PERLOPTIONS=

# Default directories install
PREFIX=/usr/local
LMPREFIX=$(PREFIX)/lemonldap-ng
RLMPREFIX=$(DESTDIR)/$(LMPREFIX)
# BIN dirs
BINDIR=$(LMPREFIX)/bin
RBINDIR=$(DESTDIR)/$(BINDIR)
DATADIR=$(LMPREFIX)/data
RDATADIR=$(DESTDIR)/$(DATADIR)


EXAMPLEROOT=`pwd`/example

# Document roots for Apache VirtualHosts
DOCUMENTROOT=$(LMPREFIX)/htdocs
PORTALDIR=$(DOCUMENTROOT)/portal
RPORTALDIR=$(DESTDIR)/$(PORTALDIR)
PORTALSKINSDIR=$(PORTALDIR)/skins
RPORTALSKINSDIR=$(DESTDIR)/$(PORTALSKINSDIR)
LASPPORTALDIR=$(DOCUMENTROOT)/liberty-alliance-sp-portal
RLASPPORTALDIR=$(DESTDIR)/$(LASPPORTALDIR)
MANAGERDIR=$(DOCUMENTROOT)/manager
RMANAGERDIR=$(DESTDIR)/$(MANAGERDIR)
MANAGERDATADIR=$(MANAGERDIR)/imgs
RMANAGERDATADIR=$(DESTDIR)/$(MANAGERDATADIR)
SESSIONSEXPLORERDIR=$(MANAGERDIR)
RSESSIONSEXPLORERDIR=$(DESTDIR)/$(SESSIONSEXPLORERDIR)
SESSIONSEXPLORERDATADIR=$(SESSIONSEXPLORERDIR)/images
RSESSIONSEXPLORERDATADIR=$(DESTDIR)/$(SESSIONSEXPLORERDATADIR)
DOCDIR=$(DOCUMENTROOT)/doc
RDOCDIR=$(DESTDIR)/$(DOCDIR)
TESTDIR=$(DOCUMENTROOT)/test
RTESTDIR=$(DESTDIR)/$(TESTDIR)
EXAMPLESDIR=$(LMPREFIX)/examples
REXAMPLESDIR=$(DESTDIR)/$(EXAMPLESDIR)
TOOLSDIR=$(LMPREFIX)/tools
RTOOLSDIR=$(DESTDIR)/$(TOOLSDIR)

# Handler dir
HANDLERDIR=$(LMPREFIX)/handler
RHANDLERDIR=$(DESTDIR)/$(HANDLERDIR)

# Configuration dir
CONFDIR=$(LMPREFIX)/etc
RCONFDIR=$(DESTDIR)/$(CONFDIR)
CRONDIR=$(LMPREFIX)/etc/cron.d
RCRONDIR=$(DESTDIR)/$(CRONDIR)
STORAGECONFFILE=$(CONFDIR)/storage.conf

# Lemonldap-ng configuration storage dir
FILECONFIGDIR=$(DATADIR)/conf
RFILECONFIGDIR=$(DESTDIR)/$(FILECONFIGDIR)

# Apache::Session::File storage dir
APACHESESSIONFILEDIR=$(DATADIR)/sessions
RAPACHESESSIONFILEDIR=$(DESTDIR)/$(APACHESESSIONFILEDIR)
APACHESESSIONFILELOCKDIR=$(APACHESESSIONFILEDIR)/lock
RAPACHESESSIONFILELOCKDIR=$(DESTDIR)/$(APACHESESSIONFILELOCKDIR)
APACHEUSER=
APACHEGROUP=

# DNS Domain for cookie and virtual hosts
DNSDOMAIN=example.com

# LDAP parameters
LDAPHOST=localhost
LDAPPORT=389
LDAPSUFFIX=dc=example,dc=net

# Other
VERSION=`head -n1 changelog |sed -e 's/lemonldap-ng (//' -e 's/).*$$//'`
SRCCOMMONDIR=lemonldap-ng-common
SRCHANDLERDIR=lemonldap-ng-handler
SRCPORTALDIR=lemonldap-ng-portal
SRCMANAGERDIR=lemonldap-ng-manager
EXAMPLELANG=en # For static Manager example only

all:	configure common handler manager portal
	@echo
	@echo "Building succeed. Now run :"
	@echo " - make test to verify your installation"
	@echo " - make install to install all"
	@echo
	@echo 'Other targets :'
	@echo " * Partial build :"
	@echo "   - portal, manager, handler"
	@echo " * Doxygen documentation"
	@echo "   - doxygen (to build Doxygen documentation in doc/devel/)"
	@echo
	@echo 'Other targets launched by "make install" :'
	@echo " * Perl libraries install :"
	@echo "   - install_libs          (all Perl libraries)"
	@echo "   - install_portal_libs"
	@echo "   - install_manager_libs"
	@echo "   - install_handler_libs"
	@echo " * Binaries install :"
	@echo "   - install_bin           ($(BINDIR))"
	@echo " * Web sites install :"
	@echo "   - install_site          (all sites including install_doc_site)"
	@echo "   - install_portal_site   ($(PORTALDIR))"
	@echo "   - install_manager_site  ($(MANAGERDIR))"
	@echo "   - install_handler_site  ($(HANDLERDIR))"
	@echo " * Documentation install :"
	@echo "   - install_doc_site      ($(DOCDIR))"
	@echo "   - install_examples_site ($(EXAMPLESDIR))"
	@echo

#
# Perl libraries configuration
#
configure:	common_conf handler_conf portal_conf manager_conf

common_conf:
	@cd ${SRCCOMMONDIR}; LMNGCONFFILE=$(STORAGECONFFILE) perl Makefile.PL $(PERLOPTIONS)
	@touch common_conf

handler_conf:
	@cd ${SRCHANDLERDIR}; perl Makefile.PL $(PERLOPTIONS)
	@touch handler_conf

portal_conf:
	@cd ${SRCPORTALDIR}; perl Makefile.PL $(PERLOPTIONS)
	@touch portal_conf

manager_conf:
	@cd ${SRCMANAGERDIR}; perl Makefile.PL $(PERLOPTIONS)
	@touch manager_conf

#
# Perl libraries make
#
common:		common_conf
	@$(MAKE) -C ${SRCCOMMONDIR}
	@touch common

handler:	handler_conf
	@$(MAKE) -C ${SRCHANDLERDIR}
	@touch handler

portal:		portal_conf
	@$(MAKE) -C ${SRCPORTALDIR}
	@touch portal

manager:	manager_conf
	@$(MAKE) -C ${SRCMANAGERDIR}
	@touch manager

test:		common handler portal manager common_test handler_test portal_test manager_test

common_test:	common
	@$(MAKE) -C ${SRCCOMMONDIR} test

handler_test:	handler common_test
	@$(MAKE) -C ${SRCHANDLERDIR} test FULLPERL="$(PERL) -I../${SRCCOMMONDIR}/blib/lib/"

portal_test:	portal handler_test common_test
	@$(MAKE) -C ${SRCPORTALDIR} test FULLPERL="$(PERL) -I../${SRCCOMMONDIR}/blib/lib/ -I../${SRCHANDLERDIR}/blib/lib/"

manager_test:	manager handler_test common_test
	@$(MAKE) -C ${SRCMANAGERDIR} test FULLPERL="$(PERL) -I../${SRCCOMMONDIR}/blib/lib/ -I../${SRCHANDLERDIR}/blib/lib/"

#
# INSTALL
#
install:	install_libs install_bin install_site

#
# Perl libraires install
#
install_libs:	common_install_libs install_handler_libs install_portal_libs install_manager_libs

common_install_libs:		common
	@$(MAKE) -C ${SRCCOMMONDIR} install

install_handler_libs:	handler
	@$(MAKE) -C ${SRCHANDLERDIR} install

install_portal_libs:		portal
	@$(MAKE) -C ${SRCPORTALDIR} install

install_manager_libs:	manager
	@$(MAKE) -C ${SRCMANAGERDIR} install

example:
	$(MAKE) install_site LMPREFIX=$(EXAMPLEROOT)

install_bin:	install_libs install_conf_dir
	# Binary install
	@install -v -d $(RBINDIR)
	@cp --preserve=mode --remove-destination \
		${SRCPORTALDIR}/example/scripts/purgeCentralCache \
		${SRCCOMMONDIR}/scripts/lmConfig_File2MySQL \
		${SRCMANAGERDIR}/example/scripts/lmConfigEditor \
			$(RBINDIR)

#
# SITE INSTALL
#
install_site:	install_manager_site install_portal_site install_handler_site install_test_site install_examples_site install_doc_site
	# Site install
	@install -v -d $(RCONFDIR)
	# Apache configuration files
	@cp --remove-destination _example/etc/apache* $(RCONFDIR)
	@perl -i -pe 's#__HANDLER__#${HANDLERDIR}/MyHandler.pm#; \
		s/__DNSDOMAIN__/$(DNSDOMAIN)/g; \
		s#__PORTALDIR__#$(PORTALDIR)/#g; \
		s#__MANAGERDIR__#$(MANAGERDIR)/#g; \
		s#__TESTDIR__#$(TESTDIR)/#g; \
		s#__DOCDIR__#$(DOCDIR)/#g;' $(RCONFDIR)/apache*
	# File for /etc/hosts inclusion
	@cp --remove-destination _example/etc/for_etc_hosts $(RCONFDIR)
	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/for_etc_hosts
	#
	@echo
	@echo "LemonLDAP::NG v${VERSION} is installed with these parameters:"
	@echo "  - System configuration: ${CONFDIR}"
	@echo "  - DNS domain (for cookies and virtual hosts): ${DNSDOMAIN}"
	@echo "  - LDAP parameters:"
	@echo "    - Host: ${LDAPHOST}"
	@echo "    - Port: ${LDAPPORT}"
	@echo "    - Suffix: ${LDAPSUFFIX}"
	@echo
	@echo "To finish configuration:"
	@echo
	@echo "1 - Add this in your Apache configuration file:"
	@echo "    with Apache-1.3.x"
	@echo "      include ${CONFDIR}/apache.conf"
	@echo "    or with Apache-2.x:"
	@echo "      include ${CONFDIR}/apache2.conf"
	@echo
	@echo "2 - Restart Apache (or Apache2)"
	@echo
	@echo "3 - Run 'make postconf' as root to update /etc/hosts" if your DNS service does not known auth.$(DNSDOMAIN) and manager.$(DNSDOMAIN)
	@echo
	@echo "4 - Use the manager at http://manager.${DNSDOMAIN}/ (after Apache restart) to modify LemonLDAP::NG configuration."
	@echo "    Edit ${RCONFDIR}/apps/apps-list.xml to modify the menu."
	@echo
	@echo "5 - Try to connect to http://test1.${DNSDOMAIN}/ or http://test2.${DNSDOMAIN}/"
	@if [ "$(APACHEUSER)" == "" ]; then \
		echo;echo "    Warning, since APACHEUSER was not set, $(APACHESESSIONFILEDIR) and $(CONFDIR) have permissive permissions."; \
		echo "    Fix them by yourself to restrict their view to apache process only"; \
	fi
	@echo

install_manager_site:	install_conf_dir
	# Manager install
	@install -v -d ${RMANAGERDIR} ${RMANAGERDATADIR} \
		${RSESSIONSEXPLORERDIR} $(RSESSIONSEXPLORERDATADIR) \
		$(RCONFDIR)
	@find ${RMANAGERDIR} -type l -name imgs -delete
	@find ${RMANAGERDIR} -type l -name images -delete
	@cp -pR --remove-destination ${SRCMANAGERDIR}/example/* ${RMANAGERDIR}
	@rm -rf $$(find ${RMANAGERDIR} -type d -name .svn) ${RMANAGERDIR}/scripts ${RMANAGERDIR}/mrtg ${RMANAGERDIR}/soapserver.pl
	@if [ "${RMANAGERDIR}/imgs/" != "${RMANAGERDATADIR}/" ]; then \
		mv -f ${RMANAGERDIR}/imgs/* ${RMANAGERDATADIR}/; \
		rm -rf ${RMANAGERDIR}/imgs; \
		ln -s $$(echo ${MANAGERDATADIR} | sed -e 's/\/$$//') ${RMANAGERDIR}/imgs; \
	fi
	# apply.conf install
	@mv ${RMANAGERDIR}/apply.conf $(RCONFDIR)
	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/apply.conf
	@perl -i -pe 's#__APPLYCONFFILE__#$(CONFDIR)/apply.conf#' ${RMANAGERDIR}/index.pl
	# Sessions explorer install
	@if [ "${MANAGERDIR}" != "$(SESSIONSEXPLORERDIR)" ]; then mv -f ${RMANAGERDIR}/sessions.pl $(RSESSIONSEXPLORERDIR); fi
	@if [ "${MANAGERDIR}/images/" != "${SESSIONSEXPLORERDATADIR}/" ]; then \
		mv -f ${RMANAGERDIR}/images/* ${RSESSIONSEXPLORERDATADIR}; \
		rm -rf ${RMANAGERDIR}/images; \
		ln -s $$(echo ${SESSIONSEXPLORERDATADIR} | sed -e 's/\/$$//') ${RMANAGERDIR}/images; \
	fi
	@rm -rf $$(find ${RMANAGERDIR} ${RMANAGERDATADIR} \
		${RSESSIONSEXPLORERDIR} $(RSESSIONSEXPLORERDATADIR) \
		$(RCONFDIR) -type d -name .svn)

install_portal_site:	install_conf_dir
	# Portal install
	@install -v -d $(RPORTALDIR) $(RPORTALSKINSDIR) \
		$(RPORTALDIR)/skins/ $(RLASPPORTALDIR) \
		$(RCRONDIR) $(RCONFDIR)
	@for skin in $$(ls lemonldap-ng-portal/example/skins/); do \
		[ -h $(RPORTALDIR)/skins/$$skin ] && rm -f $(RPORTALDIR)/skins/$$skin; \
		install -v -d $(RPORTALSKINSDIR)/$$skin; \
	done
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/index_skin.pl ${RPORTALDIR}/index.pl
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/error.pl ${RPORTALDIR}
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/apps ${RPORTALDIR}
	@perl -i -pe 's#__SKINDIR__#$(PORTALDIR)/skins#; \
		s#__APPSXMLFILE__#$(CONFDIR)/apps-list.xml#;' ${RPORTALDIR}/index.pl ${RPORTALDIR}/error.pl
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/skins/* $(RPORTALSKINSDIR)
	@if [ "$(PORTALDIR)/skins/" != "$(PORTALSKINSDIR)/" ]; then \
		for skin in $$(ls lemonldap-ng-portal/example/skins/); do \
			rm -rf $(RPORTALDIR)/skins/$$skin/; \
			ln -s $(PORTALSKINSDIR)/$$skin $(RPORTALDIR)/skins/$$skin; \
		done; \
	fi
	@cp --remove-destination _example/etc/apps-list* $(RCONFDIR)
	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/apps-list.xml
	# L-A portal install
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/AuthLA/* $(RLASPPORTALDIR)
	@perl -i -pe 's#__DIR__#$(LASPPORTALDIR)/#g' $(RLASPPORTALDIR)/index.pl
	# Cron files
	@cp --remove-destination lemonldap-ng-portal/example/scripts/purgeCentralCache.cron.d $(RCRONDIR)
	# Clean SVN files
	@rm -rf $$(find ${RPORTALDIR} $(RPORTALSKINSDIR) $(RLASPPORTALDIR) $(RCRONDIR) $(RCONFDIR) -type d -name .svn)

install_handler_site:	install_conf_dir
	# Handler install
	@install -v -d ${RHANDLERDIR}
	@cp --remove-destination ${SRCHANDLERDIR}/example/MyHandler.pm ${RHANDLERDIR}
	@rm -rf $$(find $(RHANDLERDIR) -type d -name .svn)

install_test_site:
	# Test site install
	@install -v -d $(RTESTDIR)
	@cp -pR --remove-destination _example/test/* $(RTESTDIR)
	@rm -rf $$(find $(RTESTDIR) -type d -name .svn)
	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RTESTDIR)/index.pl
	@rm -rf $$(find $(RTESTDIR) -type d -name .svn)

install_examples_site:
	# Examples install
	@install -v -d $(REXAMPLESDIR)
	@for i in manager portal handler; do \
		cp -dpR --remove-destination lemonldap-ng-$$i/example $(REXAMPLESDIR)/$$i; \
	done
	@rm -rf $(REXAMPLESDIR)/portal/skins \
		$(REXAMPLESDIR)/manager/imgs \
		$(REXAMPLESDIR)/manager/images \
	@rm -rf $$(find $(REXAMPLESDIR) -type d -name .svn)
	@perl -i -pe 's#__DIR__#$(LASPPORTALDIR)#g' $(REXAMPLESDIR)/portal/AuthLA/index.pl
	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(REXAMPLESDIR)/manager/apply.conf
	@perl -i -pe 's#__APPLYCONFFILE__#$(CONFDIR)/apply.conf#' $(REXAMPLESDIR)/manager/*.pl

## lemonldap-ng 0.9.4.1

=== Makefile ===
--- 
+++ 
@@ -75,7 +75,7 @@
 # LDAP parameters
 LDAPHOST=localhost
 LDAPPORT=389
-LDAPSUFFIX=dc=example,dc=net
+LDAPSUFFIX=dc=example,dc=com
 
 # Other
 VERSION=`head -n1 changelog |sed -e 's/lemonldap-ng (//' -e 's/).*$$//'`
@@ -84,6 +84,7 @@
 SRCPORTALDIR=lemonldap-ng-portal
 SRCMANAGERDIR=lemonldap-ng-manager
 EXAMPLELANG=en # For static Manager example only
+ERASECONFIG=1 # Set to 0 if you do not want to replace your configuration
 
 all:	configure common handler manager portal
 	@echo
@@ -199,9 +200,12 @@
 	@install -v -d $(RBINDIR)
 	@cp --preserve=mode --remove-destination \
 		${SRCPORTALDIR}/example/scripts/purgeCentralCache \
+		${SRCPORTALDIR}/example/scripts/buildPortalWSDL \
 		${SRCCOMMONDIR}/scripts/lmConfig_File2MySQL \
+		${SRCCOMMONDIR}/scripts/lmConfig_File2LDIF \
 		${SRCMANAGERDIR}/example/scripts/lmConfigEditor \
 			$(RBINDIR)
+	chmod +x $(RBINDIR)/*
 
 #
 # SITE INSTALL
@@ -209,18 +213,18 @@
 install_site:	install_manager_site install_portal_site install_handler_site install_test_site install_examples_site install_doc_site
 	# Site install
 	@install -v -d $(RCONFDIR)
-	# Apache configuration files
-	@cp --remove-destination _example/etc/apache* $(RCONFDIR)
+	# Check if erase is wanted
+	@if [ "$(ERASECONFIG)" -eq "1" ]; then \
+		cp --remove-destination  _example/etc/apache* $(RCONFDIR); \
+		cp --remove-destination _example/etc/for_etc_hosts $(RCONFDIR); \
+	fi
 	@perl -i -pe 's#__HANDLER__#${HANDLERDIR}/MyHandler.pm#; \
-		s/__DNSDOMAIN__/$(DNSDOMAIN)/g; \
-		s#__PORTALDIR__#$(PORTALDIR)/#g; \
-		s#__MANAGERDIR__#$(MANAGERDIR)/#g; \
-		s#__TESTDIR__#$(TESTDIR)/#g; \
-		s#__DOCDIR__#$(DOCDIR)/#g;' $(RCONFDIR)/apache*
-	# File for /etc/hosts inclusion
-	@cp --remove-destination _example/etc/for_etc_hosts $(RCONFDIR)
+			s/__DNSDOMAIN__/$(DNSDOMAIN)/g; \
+			s#__PORTALDIR__#$(PORTALDIR)/#g; \
+			s#__MANAGERDIR__#$(MANAGERDIR)/#g; \
+			s#__TESTDIR__#$(TESTDIR)/#g; \
+			s#__DOCDIR__#$(DOCDIR)/#g;' $(RCONFDIR)/apache*
 	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/for_etc_hosts
-	#
 	@echo
 	@echo "LemonLDAP::NG v${VERSION} is installed with these parameters:"
 	@echo "  - System configuration: ${CONFDIR}"
@@ -246,7 +250,7 @@
 	@echo "    Edit ${RCONFDIR}/apps/apps-list.xml to modify the menu."
 	@echo
 	@echo "5 - Try to connect to http://test1.${DNSDOMAIN}/ or http://test2.${DNSDOMAIN}/"
-	@if [ "$(APACHEUSER)" == "" ]; then \
+	@if [ ! "$(APACHEUSER)" ]; then \
 		echo;echo "    Warning, since APACHEUSER was not set, $(APACHESESSIONFILEDIR) and $(CONFDIR) have permissive permissions."; \
 		echo "    Fix them by yourself to restrict their view to apache process only"; \
 	fi
@@ -266,8 +270,10 @@
 		rm -rf ${RMANAGERDIR}/imgs; \
 		ln -s $$(echo ${MANAGERDATADIR} | sed -e 's/\/$$//') ${RMANAGERDIR}/imgs; \
 	fi
-	# apply.conf install
-	@mv ${RMANAGERDIR}/apply.conf $(RCONFDIR)
+	# apply.conf install if erase configuration is wanted
+	@if [ "$(ERASECONFIG)" -eq "1" ]; then \
+		mv -f ${RMANAGERDIR}/apply.conf "$(RCONFDIR)"; \
+	fi
 	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/apply.conf
 	@perl -i -pe 's#__APPLYCONFFILE__#$(CONFDIR)/apply.conf#' ${RMANAGERDIR}/index.pl
 	# Sessions explorer install
@@ -302,13 +308,22 @@
 			ln -s $(PORTALSKINSDIR)/$$skin $(RPORTALDIR)/skins/$$skin; \
 		done; \
 	fi
-	@cp --remove-destination _example/etc/apps-list* $(RCONFDIR)
+	# Applications list install if erase configuration is needed
+	@if [ "$(ERASECONFIG)" -eq "1" ]; then \
+		cp --remove-destination _example/etc/apps-list* $(RCONFDIR); \
+	fi
 	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/apps-list.xml
 	# L-A portal install
 	@cp -pR --remove-destination ${SRCPORTALDIR}/example/AuthLA/* $(RLASPPORTALDIR)
 	@perl -i -pe 's#__DIR__#$(LASPPORTALDIR)/#g' $(RLASPPORTALDIR)/index.pl
 	# Cron files
-	@cp --remove-destination lemonldap-ng-portal/example/scripts/purgeCentralCache.cron.d $(RCRONDIR)
+	@cp --remove-destination lemonldap-ng-portal/example/scripts/purgeCentralCache.cron.d $(RCRONDIR)/lemonldap-ng
+	@if [ ! "$(APACHEUSER)" ]; then \
+		perl -i -pe 's#__APACHEUSER__#root#g;' $(RCRONDIR)/lemonldap-ng; \
+	else \
+		perl -i -pe 's#__APACHEUSER__#$(APACHEUSER)#g;' $(RCRONDIR)/lemonldap-ng; \
+	fi
+	@perl -i -pe 's#__BINDIR__#$(BINDIR)#g;' $(RCRONDIR)/lemonldap-ng
 	# Clean SVN files
 	@rm -rf $$(find ${RPORTALDIR} $(RPORTALSKINSDIR) $(RLASPPORTALDIR) $(RCRONDIR) $(RCONFDIR) -type d -name .svn)
 
@@ -323,19 +338,3 @@
 	@install -v -d $(RTESTDIR)
 	@cp -pR --remove-destination _example/test/* $(RTESTDIR)
 	@rm -rf $$(find $(RTESTDIR) -type d -name .svn)
-	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RTESTDIR)/index.pl
-	@rm -rf $$(find $(RTESTDIR) -type d -name .svn)
-
-install_examples_site:
-	# Examples install
-	@install -v -d $(REXAMPLESDIR)
-	@for i in manager portal handler; do \
-		cp -dpR --remove-destination lemonldap-ng-$$i/example $(REXAMPLESDIR)/$$i; \
-	done
-	@rm -rf $(REXAMPLESDIR)/portal/skins \
-		$(REXAMPLESDIR)/manager/imgs \
-		$(REXAMPLESDIR)/manager/images \
-	@rm -rf $$(find $(REXAMPLESDIR) -type d -name .svn)
-	@perl -i -pe 's#__DIR__#$(LASPPORTALDIR)#g' $(REXAMPLESDIR)/portal/AuthLA/index.pl
-	@perl -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(REXAMPLESDIR)/manager/apply.conf
-	@perl -i -pe 's#__APPLYCONFFILE__#$(CONFDIR)/apply.conf#' $(REXAMPLESDIR)/manager/*.pl

=== debian/changelog ===
lemonldap-ng (0.9.4.1-5) unstable; urgency=low

  * Fix bug "cleanup sub slows down considerably the Apache server"
    (Closes: #599688)

 -- Xavier Guimard <x.guimard@free.fr>  Sun, 10 Oct 2010 10:24:04 +0200

lemonldap-ng (0.9.4.1-4) unstable; urgency=low

  * Spanish po-debconf template translation (Closes: #584453)
  * Debian policy update

 -- Xavier Guimard <x.guimard@free.fr>  Sat, 18 Sep 2010 06:56:36 +0200

lemonldap-ng (0.9.4.1-3) unstable; urgency=low

  * Japanese po-debconf template translation (Closes: #559396)
  * Debian policy update

 -- Xavier Guimard <x.guimard@free.fr>  Sat, 13 Feb 2010 14:36:40 +0100

lemonldap-ng (0.9.4.1-2) unstable; urgency=low

  * Lintian :
    - lintian.override for liblemonldap-ng-conf
    - registering doc
  * change lemonldap-ng section to perl as claimed by archive-administrator

 -- Xavier Guimard <x.guimard@free.fr>  Mon, 12 Oct 2009 16:26:26 +0200

lemonldap-ng (0.9.4.1-1) unstable; urgency=low

  * New upstream release
  * Russian translation (Closes: #550552)

 -- Xavier Guimard <x.guimard@free.fr>  Mon, 12 Oct 2009 14:40:46 +0200

lemonldap-ng (0.9.4-1) unstable; urgency=low

  * New upstream release
  * Closes: #512009 (closed since 0.9.3.2)

 -- Xavier Guimard <x.guimard@free.fr>  Sun, 05 Jul 2009 13:46:54 +0200

lemonldap-ng (0.9.3.4-2) unstable; urgency=low

  * Missing build-depends libregexp-assemble-perl (Closes: #521959)

 -- Xavier Guimard <x.guimard@free.fr>  Sat, 11 Apr 2009 08:14:19 +0200

lemonldap-ng (0.9.3.4-1) unstable; urgency=low

  * New upstream release
  * Closes 3 bugs (see
    http://forge.objectweb.org/tracker/?atid=350401&group_id=274&func=browse
    bugs number 312418, 312625 and 312627)

 -- Xavier Guimard <x.guimard@free.fr>  Thu, 05 Feb 2009 16:27:16 +0100

lemonldap-ng (0.9.3.2-1) unstable; urgency=low

  * New upstream release
  * Closes: #510562
  * Closes: #510563

 -- Xavier Guimard <x.guimard@free.fr>  Sat, 03 Jan 2009 09:51:55 +0100

lemonldap-ng (0.9.3-1) unstable; urgency=low

  * New upstream release

 -- Xavier Guimard <x.guimard@free.fr>  Wed, 31 Dec 2008 12:11:50 +0100

lemonldap-ng (0.9.2-1) unstable; urgency=low

  * New upstream release
  * Czech translation for debconf (Closes: #483301)
  * Swedish translation for debconf (Closes: #487713)

 -- Xavier Guimard <x.guimard@free.fr>  Tue, 24 Jun 2008 15:12:09 +0200

lemonldap-ng (0.9.1-1) unstable; urgency=low

  * New upstream release

 -- Xavier Guimard <x.guimard@free.fr>  Fri, 11 Apr 2008 16:48:59 +0200

lemonldap-ng (0.9-1) unstable; urgency=low

  New upstream release
  * purgeCentralCache was not correctly installed (Closes: #461572)
  * Portuguese debconf translation (Closes: #451820)
  * German debconf translation (Closes: #462807)

 -- Xavier Guimard <x.guimard@free.fr>  Mon, 25 Feb 2008 15:06:49 +0100

lemonldap-ng (0.8.3.1-1) unstable; urgency=low

  * Initial release. (Closes: #429441: ITP: lemonldap-ng -- lemonldap-ng
    is a Perl web single-sign-on system usable as Apache module - Debian
    Bug report logs)

 -- Xavier Guimard <x.guimard@free.fr>  Wed, 07 Nov 2007 16:51:23 +0100

=== debian/control ===
Source: lemonldap-ng
Section: perl
Priority: extra
Maintainer: Xavier Guimard <x.guimard@free.fr>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7), po-debconf
Build-Depends-Indep:libapache-session-perl, libnet-ldap-perl, libdbi-perl, libwww-perl, libcache-cache-perl, libxml-simple-perl, libcrypt-rijndael-perl, libcgi-session-perl, libxml-libxslt-perl, libio-string-perl, libregexp-assemble-perl, liburi-perl, libstring-random-perl, libmime-lite-perl, libsoap-lite-perl
Standards-Version: 3.9.1

Package: lemonldap-ng
Architecture: all
Depends: ${misc:Depends}, liblemonldap-ng-handler-perl (= ${binary:Version}), liblemonldap-ng-manager-perl (= ${binary:Version}), liblemonldap-ng-portal-perl (= ${binary:Version})
Description: Lemonldap::NG Web-SSO system
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application Apache servers.
 .
 This package is a metapackage that install handler, manager and portal.

Package: lemonldap-ng-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Lemonldap::NG Web-SSO system documentation
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application Apache servers.
 .
 This package contains html documentation.

Package: liblemonldap-ng-handler-perl
Architecture: all
Depends: ${misc:Depends}, libapache-session-perl, libwww-perl, libcache-cache-perl, liblemonldap-ng-conf-perl (= ${binary:Version}), libapache2-mod-perl2 | libapache-mod-perl, liburi-perl
Suggests: liblemonldap-ng-portal-perl
Description: Lemonldap::NG Apache module part
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application Apache servers.
 .
 This package installs the Apache module part (handler) used to protect web
 areas.

Package: liblemonldap-ng-conf-perl
Architecture: all
Depends: ${misc:Depends}, libdbi-perl, debconf, libcache-cache-perl, libregexp-assemble-perl, libcrypt-rijndael-perl
Recommends: libsoap-lite-perl
Description: Lemonldap::NG common files
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application Apache servers.
 .
 This package installs common files used by other Lemonldap::NG modules.

Package: liblemonldap-ng-manager-perl
Architecture: all
Depends: ${misc:Depends}, libxml-simple-perl, liblemonldap-ng-conf-perl (= ${binary:Version}), libjs-jquery, liblemonldap-ng-handler-perl (= ${binary:Version})
Recommends: libcache-cache-perl, libapache-session-perl, libsoap-lite-perl
Description: Lemonldap::NG manager part
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application Apache servers.
 .
 This package installs the administration interface (manager).

Package: liblemonldap-ng-portal-perl
Architecture: all
Depends: ${misc:Depends}, libapache-session-perl, libnet-ldap-perl, liblemonldap-ng-conf-perl (= ${binary:Version}), libhtml-template-perl, libjs-jquery, liblemonldap-ng-handler-perl (= ${binary:Version}), libxml-libxml-perl, libxml-libxslt-perl, libstring-random-perl, libsoap-lite-perl
Recommends: libmime-lite-perl
Suggests: liblasso-perl, libcgi-session-perl, slapd
Description: Lemonldap::NG authentication portal part
 Lemonldap::NG is a complete Web-SSO system that can run with reverse-proxies
 or directly on application Apache servers.
 .
 This package installs the authentication portal.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export PERL_MM_USE_DEFAULT=1

LMSHAREDIR=/usr/share/lemonldap-ng/
LMVARDIR=/var/lib/lemonldap-ng/

configure: configure-stamp
configure-stamp:
	dh_testdir

	# Add here commands to configure the package.
	$(MAKE) configure STORAGECONFFILE=/etc/lemonldap-ng/storage.conf \
			PERLOPTIONS="INSTALLDIRS=vendor"

	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	debconf-updatepo
	rm -f build-stamp configure-stamp

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/lemonldap-ng.
	$(MAKE) test
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp \
			PREFIX=/usr/ \
			BINDIR=$(LMSHAREDIR)bin/ \
			DOCUMENTROOT=$(LMVARDIR) \
			EXAMPLESDIR=/examples/ \
			HANDLERDIR=$(LMVARDIR)handler/ \
			PORTALSKINSDIR=$(LMSHAREDIR)portal-skins/ \
			MANAGERDATADIR=$(LMSHAREDIR)manager-imgs/ \
			SESSIONSEXPLORERDATADIR=$(LMSHAREDIR)sessions-explorer-imgs/ \
			STORAGECONFFILE=/etc/lemonldap-ng/storage.conf \
			TOOLSDIR=$(LMSHAREDIR)ressources/ \
			CONFDIR=/etc/lemonldap-ng/ \
			CRONDIR=/etc/cron.d/ \
			DATADIR=$(LMVARDIR) \
			APACHEUSER=www-data \
			APACHEGROUP=www-data

	# Since Lenny, jquery.js is provided by libjs-jquery
	rm -f $(CURDIR)/debian/tmp$(LMSHAREDIR)portal-skins/*/jquery.js \
		$(CURDIR)/debian/tmp$(LMVARDIR)manager/jquery.js \
		debian/tmp/examples/manager/jquery.js
	perl -i -pe 's#(["'"'"'])[\w-\./]*jquery.js#$$1/javascript/jquery/jquery.js#' \
			$(CURDIR)/debian/tmp/examples/manager/*.pl \
			$(CURDIR)/debian/tmp$(LMSHAREDIR)portal-skins/pastel/header.tpl
	# postinst provides initial portal, manager and sessions-explorer
	rm -f debian/tmp/var/lib/lemonldap-ng/portal/index.pl \
		debian/tmp/var/lib/lemonldap-ng/liberty-alliance-sp-portal/index.pl \
		debian/tmp/var/lib/lemonldap-ng/manager/index.pl \
		debian/tmp/var/lib/lemonldap-ng/manager/sessions.pl

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs changelog
	dh_installdocs
	dh_installexamples
	dh_install
	mkdir -p debian/lemonldap-ng/usr/share/doc/lemonldap-ng/examples && \
		cd debian/lemonldap-ng/usr/share/doc/lemonldap-ng/examples && \
		ln -s ../../liblemonldap-ng-handler-perl/examples handler && \
		ln -s ../../liblemonldap-ng-manager-perl/examples manager && \
		ln -s ../../liblemonldap-ng-portal-perl/examples portal
	chmod +x debian/liblemonldap-ng-portal-perl$(LMSHAREDIR)bin/purgeCentralCache
#	dh_installmenu
	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_python
#	dh_installinit
	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress -X.pm -X.pl
	dh_fixperms
#	dh_perl
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-dependent files here.
binary-arch: build install

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## lemonldap-ng 1.0

=== Makefile ===
#!/usr/bin/make

# Prefix for packaging
DESTDIR=

PERL=$$(which perl)
SU=su -c
COMPRESS=tar czf
UNCOMPRESS=tar xzf
LISTCOMPRESSED=tar tzf
COMPRESSSUFFIX=tar.gz
# Perl options
#PERLOPTIONS="INSTALLDIRS=vendor"
PERLOPTIONS=

# Default directories install
PREFIX=/usr/local
LMPREFIX=$(PREFIX)/lemonldap-ng
RLMPREFIX=$(DESTDIR)/$(LMPREFIX)
# BIN dirs
BINDIR=$(LMPREFIX)/bin
RBINDIR=$(DESTDIR)/$(BINDIR)
DATADIR=$(LMPREFIX)/data
RDATADIR=$(DESTDIR)/$(DATADIR)

EXAMPLEROOT=`pwd`/example

# Document roots for Apache VirtualHosts
DOCUMENTROOT=$(LMPREFIX)/htdocs
PORTALDIR=$(DOCUMENTROOT)/portal
RPORTALDIR=$(DESTDIR)/$(PORTALDIR)
PORTALSKINSDIR=$(PORTALDIR)/skins
RPORTALSKINSDIR=$(DESTDIR)/$(PORTALSKINSDIR)
MANAGERDIR=$(DOCUMENTROOT)/manager
RMANAGERDIR=$(DESTDIR)/$(MANAGERDIR)
MANAGERSKINSDIR=$(MANAGERDIR)/skins
RMANAGERSKINSDIR=$(DESTDIR)/$(MANAGERSKINSDIR)
SESSIONSEXPLORERDIR=$(MANAGERDIR)
RSESSIONSEXPLORERDIR=$(DESTDIR)/$(SESSIONSEXPLORERDIR)
DOCDIR=$(DOCUMENTROOT)/doc
RDOCDIR=$(DESTDIR)/$(DOCDIR)
TESTDIR=$(DOCUMENTROOT)/test
RTESTDIR=$(DESTDIR)/$(TESTDIR)
EXAMPLESDIR=$(LMPREFIX)/examples
REXAMPLESDIR=$(DESTDIR)/$(EXAMPLESDIR)
TOOLSDIR=$(LMPREFIX)/tools
RTOOLSDIR=$(DESTDIR)/$(TOOLSDIR)

# Handler dir
HANDLERDIR=$(LMPREFIX)/handler
RHANDLERDIR=$(DESTDIR)/$(HANDLERDIR)

# Configuration dir
CONFDIR=$(LMPREFIX)/etc
RCONFDIR=$(DESTDIR)/$(CONFDIR)
CRONDIR=$(LMPREFIX)/etc/cron.d
RCRONDIR=$(DESTDIR)/$(CRONDIR)
CONFFILENAME=lemonldap-ng.ini
STORAGECONFFILE=$(CONFDIR)/$(CONFFILENAME)

# Lemonldap-ng configuration storage dir
FILECONFIGDIR=$(DATADIR)/conf
RFILECONFIGDIR=$(DESTDIR)/$(FILECONFIGDIR)

# Apache::Session::File storage dir
APACHESESSIONFILEDIR=$(DATADIR)/sessions
RAPACHESESSIONFILEDIR=$(DESTDIR)/$(APACHESESSIONFILEDIR)
APACHESESSIONFILELOCKDIR=$(APACHESESSIONFILEDIR)/lock
RAPACHESESSIONFILELOCKDIR=$(DESTDIR)/$(APACHESESSIONFILELOCKDIR)

# Apache user/group
APACHEUSER=
APACHEGROUP=

# Apache version
APACHEVERSION=2

# DNS Domain for cookie and virtual hosts
DNSDOMAIN=example.com

# LDAP parameters
LDAPHOST=localhost
LDAPPORT=389
LDAPSUFFIX=dc=example,dc=com

# Virtual Host Listen IP and Port (*, *:80, ...)
VHOSTLISTEN=*:80

# Other
VERSION=`head -n1 changelog |sed -e 's/lemonldap-ng (//' -e 's/).*$$//'`
PORTALSKINS=`ls lemonldap-ng-portal/example/skins/`
MANAGERSKINS=`ls lemonldap-ng-manager/example/skins/`
DIFF=diff -aburN -x '*.bak' -x .svn -x '*.swp' --ignore-matching-lines='.*jquery.*' --ignore-matching-lines='.*lemonldap-ng\.ini.*'

SRCCOMMONDIR=lemonldap-ng-common
SRCHANDLERDIR=lemonldap-ng-handler
SRCPORTALDIR=lemonldap-ng-portal
SRCMANAGERDIR=lemonldap-ng-manager
EXAMPLELANG=en # For static Manager example only
ERASECONFIG=1 # Set to 0 if you do not want to replace your configuration

DIFFPREFIX=

all:	configure common handler manager portal
	@echo
	@echo "Building succeed. Now run :"
	@echo " - make test to verify your installation"
	@echo " - make install to install all"
	@echo
	@echo 'Other targets :'
	@echo " * Partial build :"
	@echo "   - portal, manager, handler"
	@echo " * Doxygen documentation"
	@echo "   - doxygen (to build Doxygen documentation in doc/devel/)"
	@echo
	@echo 'Other targets launched by "make install" :'
	@echo " * Perl libraries install :"
	@echo "   - install_libs          (all Perl libraries)"
	@echo "   - install_portal_libs"
	@echo "   - install_manager_libs"
	@echo "   - install_handler_libs"
	@echo " * Binaries install :"
	@echo "   - install_bin           ($(BINDIR))"
	@echo " * Web sites install :"
	@echo "   - install_site          (all sites including install_doc_site)"
	@echo "   - install_portal_site   ($(PORTALDIR))"
	@echo "   - install_manager_site  ($(MANAGERDIR))"
	@echo "   - install_handler_site  ($(HANDLERDIR))"
	@echo " * Documentation install :"
	@echo "   - install_doc_site      ($(DOCDIR))"
	@echo "   - install_examples_site ($(EXAMPLESDIR))"
	@echo

#
# Perl libraries configuration
#

configure:	common_conf handler_conf portal_conf manager_conf

common_conf:
	@cd ${SRCCOMMONDIR}; LMNGCONFFILE=$(STORAGECONFFILE) $(PERL) Makefile.PL $(PERLOPTIONS)
	@touch common_conf

handler_conf:
	@cd ${SRCHANDLERDIR}; $(PERL) Makefile.PL $(PERLOPTIONS)
	@touch handler_conf

portal_conf:
	@cd ${SRCPORTALDIR}; $(PERL) Makefile.PL $(PERLOPTIONS)
	@touch portal_conf

manager_conf:
	@cd ${SRCMANAGERDIR}; $(PERL) Makefile.PL $(PERLOPTIONS)
	@touch manager_conf

#
# Perl libraries make
#
common:		common_conf
	@$(MAKE) -C ${SRCCOMMONDIR}
	@touch common

handler:	handler_conf
	@$(MAKE) -C ${SRCHANDLERDIR}
	@touch handler

portal:		portal_conf
	@$(MAKE) -C ${SRCPORTALDIR}
	@touch portal

manager:	manager_conf
	@$(MAKE) -C ${SRCMANAGERDIR}
	@touch manager

test:		all common_test handler_test portal_test manager_test extra_test

common_test:	common
	@$(MAKE) -C ${SRCCOMMONDIR} test

handler_test:	handler common_test
	@$(MAKE) -C ${SRCHANDLERDIR} test FULLPERL="$(PERL) -I../${SRCCOMMONDIR}/blib/lib/"

portal_test:	portal handler_test common_test
	@$(MAKE) -C ${SRCPORTALDIR} test FULLPERL="$(PERL) -I../${SRCCOMMONDIR}/blib/lib/ -I../${SRCHANDLERDIR}/blib/lib/"

manager_test:	manager handler_test common_test
	@$(MAKE) -C ${SRCMANAGERDIR} test FULLPERL="$(PERL) -I../${SRCCOMMONDIR}/blib/lib/ -I../${SRCHANDLERDIR}/blib/lib/"

extra_test:	all
	PERL_DL_NONLAZY=1 $(PERL) "-MExtUtils::Command::MM" "-e" "test_harness(0, 'lemonldap-ng-common/blib/lib', 'lemonldap-ng-handler/blib/lib', 'lemonldap-ng-manager/blib/lib', 'lemonldap-ng-portal/blib/lib')" extra-tests/*.t

#
# INSTALL
#
install:	install_libs install_bin install_site

#
# Perl libraires install
#
install_libs:	common_install_libs install_handler_libs install_portal_libs install_manager_libs

common_install_libs:		common
	@$(MAKE) -C ${SRCCOMMONDIR} install

install_handler_libs:	handler
	@$(MAKE) -C ${SRCHANDLERDIR} install

install_portal_libs:		portal
	@$(MAKE) -C ${SRCPORTALDIR} install

install_manager_libs:	manager
	@$(MAKE) -C ${SRCMANAGERDIR} install

example:
	$(MAKE) install_site install_bin LMPREFIX=$(EXAMPLEROOT)

install_bin:	install_conf_dir
	# Binary install
	@install -v -d $(RBINDIR)
	@cp --preserve=mode --remove-destination \
		${SRCHANDLERDIR}/example/scripts/purgeLocalCache \
		${SRCPORTALDIR}/example/scripts/purgeCentralCache \
		${SRCPORTALDIR}/example/scripts/buildPortalWSDL \
		${SRCCOMMONDIR}/scripts/convertConfig \
		${SRCCOMMONDIR}/scripts/lmMigrateConfFiles2ini \
		${SRCMANAGERDIR}/example/scripts/lmConfigEditor \
			$(RBINDIR)
	@if [ ! "$(APACHEUSER)" ]; then \
		$(PERL) -i -pe 's#__APACHEUSER__#nobody#g;' $(RBINDIR)/lmConfigEditor; \
	else \
		$(PERL) -i -pe 's#__APACHEUSER__#$(APACHEUSER)#g;' $(RBINDIR)/lmConfigEditor; \
	fi
	@if [ ! "$(APACHEGROUP)" ]; then \
		$(PERL) -i -pe 's#__APACHEGROUP__#nobody#g;' $(RBINDIR)/lmConfigEditor; \
	else \
		$(PERL) -i -pe 's#__APACHEGROUP__#$(APACHEGROUP)#g;' $(RBINDIR)/lmConfigEditor; \
	fi
	@chmod +x $(RBINDIR)/*

#
# SITE INSTALL
#
install_site:	install_manager_site install_portal_site install_handler_site install_test_site install_examples_site install_doc_site
	# Site install
	@install -v -d $(RCONFDIR)
	# Check if erase is wanted
	@if [ "$(ERASECONFIG)" -eq "1" ]; then \
		cp --remove-destination _example/etc/portal-apache$(APACHEVERSION).conf $(RCONFDIR); \
		cp --remove-destination _example/etc/handler-apache$(APACHEVERSION).conf $(RCONFDIR); \
		cp --remove-destination _example/etc/manager-apache$(APACHEVERSION).conf $(RCONFDIR); \
		cp --remove-destination _example/etc/for_etc_hosts $(RCONFDIR); \
	fi
	@$(PERL) -i -pe 's#__HANDLER__#${HANDLERDIR}/MyHandler.pm#; \
			s/__DNSDOMAIN__/$(DNSDOMAIN)/g; \
			s#__PORTALDIR__#$(PORTALDIR)/#g; \
			s#__MANAGERDIR__#$(MANAGERDIR)/#g; \
			s#__TESTDIR__#$(TESTDIR)/#g; \
			s#__VHOSTLISTEN__#$(VHOSTLISTEN)#g; \
			s#__DOCDIR__#$(DOCDIR)/#g;' $(RCONFDIR)/*apache*.conf
	@$(PERL) -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/for_etc_hosts
	# Fix a lost of rights on the main directory
	@chmod 755 $(RBINDIR) $(RDOCUMENTROOT) $(REXAMPLESDIR) $(RHANDLERDIR) $(RPORTALSKINSDIR) $(RMANAGERSKINSDIR) $(RTOOLSDIR) $(RCONFDIR) $(RDATADIR)
	@echo
	@echo "LemonLDAP::NG v${VERSION} is installed with these parameters:"
	@echo "  - System configuration: ${CONFDIR}"
	@echo "  - DNS domain (for cookies and virtual hosts): ${DNSDOMAIN}"
	@echo "  - LDAP parameters:"
	@echo "    - Host: ${LDAPHOST}"
	@echo "    - Port: ${LDAPPORT}"
	@echo "    - Suffix: ${LDAPSUFFIX}"
	@echo
	@echo "To finish configuration:"
	@echo
	@echo "1 - Add this in your Apache $(APACHEVERSION) configuration file:"
	@echo "      include ${CONFDIR}/portal-apache$(APACHEVERSION).conf"
	@echo "      include ${CONFDIR}/handler-apache$(APACHEVERSION).conf"
	@echo "      include ${CONFDIR}/manager-apache$(APACHEVERSION).conf"
	@echo
	@echo "2 - Restart Apache:"
	@echo "      apache$(APACHEVERSION)ctl restart"
	@echo
	@echo "3 - Run 'make postconf' as root to update /etc/hosts if your DNS service does not known auth.$(DNSDOMAIN) and manager.$(DNSDOMAIN)"
	@echo
	@echo "4 - Use the manager from localhost at http://manager.${DNSDOMAIN}/ (after Apache restart) to modify LemonLDAP::NG configuration."
	@echo "      Warning: If you access http://manager.${DNSDOMAIN}/ from other host, modify first Apache Manager configuration to allow access from non local address."
	@echo
	@echo "5 - Try to connect to http://test1.${DNSDOMAIN}/ or http://test2.${DNSDOMAIN}/"
	@if [ ! "$(APACHEUSER)" ]; then \
		echo;echo "    Warning, since APACHEUSER was not set, $(APACHESESSIONFILEDIR) and $(CONFDIR) have permissive permissions."; \
		echo "    Fix them by yourself to restrict their view to apache process only"; \
	fi
	@echo

install_manager_site:	install_conf_dir
	# Manager install
	@install -v -d ${RMANAGERDIR} ${RMANAGERSKINSDIR} \
		${RSESSIONSEXPLORERDIR} \
		$(RCONFDIR) ${RMANAGERDIR}/skins/
	@for skin in $$(ls lemonldap-ng-manager/example/skins/); do \
		[ -h $(RMANAGERDIR)/skins/$$skin ] && rm -f $(RMANAGERDIR)/skins/$$skin; \
		install -v -d $(RMANAGERSKINSDIR)/$$skin; \
	done
	@cp -pR --remove-destination ${SRCMANAGERDIR}/example/index.pl ${RMANAGERDIR}
	@cp -pR --remove-destination ${SRCMANAGERDIR}/example/notfound.html ${RMANAGERDIR}
	@cp -pR --remove-destination ${SRCMANAGERDIR}/example/skins/* $(RMANAGERSKINSDIR)
	@if [ "$(MANAGERDIR)/skins/" != "$(MANAGERSKINSDIR)/" ]; then \
		for skin in $$(ls lemonldap-ng-manager/example/skins/); do \
			rm -rf $(RMANAGERDIR)/skins/$$skin/; \
			ln -s $(MANAGERSKINSDIR)/$$skin $(RMANAGERDIR)/skins/$$skin; \
		done; \
	fi
	@$(PERL) -i -pe 's/__DNSDOMAIN__/$(DNSDOMAIN)/g' $(RCONFDIR)/$(CONFFILENAME)
	# Sessions explorer install
	@cp -pR --remove-destination ${SRCMANAGERDIR}/example/sessions.pl $(RSESSIONSEXPLORERDIR)
	@rm -rf $$(find ${RMANAGERDIR} ${RMANAGERSKINSDIR} \
		${RSESSIONSEXPLORERDIR} \
		$(RCONFDIR) -type d -name .svn)

install_portal_site:	install_conf_dir
	# Portal install
	@install -v -d $(RPORTALDIR) $(RPORTALSKINSDIR) \
		$(RPORTALDIR)/skins/ \
		$(RCRONDIR) $(RCONFDIR)
	@for skin in $$(ls lemonldap-ng-portal/example/skins/); do \
		[ -h $(RPORTALDIR)/skins/$$skin ] && rm -f $(RPORTALDIR)/skins/$$skin; \
		install -v -d $(RPORTALSKINSDIR)/$$skin; \
	done
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/index_skin.pl ${RPORTALDIR}/index.pl
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/mail.pl ${RPORTALDIR}
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/metadata.pl ${RPORTALDIR}
	@cp -pR --remove-destination ${SRCPORTALDIR}/example/cdc.pl ${RPORTALDIR}
	@tar -cf - -C ${SRCPORTALDIR}/example/skins/ $$(ls ${SRCPORTALDIR}/example/skins/) |tar -xf - -C $(RPORTALSKINSDIR)
	@if [ "$(PORTALDIR)/skins/" != "$(PORTALSKINSDIR)/" ]; then \
		for skin in $$(ls lemonldap-ng-portal/example/skins/); do \
			rm -rf $(RPORTALDIR)/skins/$$skin/; \
			ln -s $(PORTALSKINSDIR)/$$skin $(RPORTALDIR)/skins/$$skin; \
		done; \
	fi
	# Cron files
	@cp --remove-destination lemonldap-ng-portal/example/scripts/purgeCentralCache.cron.d $(RCRONDIR)/lemonldap-ng-portal
	@if [ ! "$(APACHEUSER)" ]; then \
